
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/rtfm/apt/">
      
      
        <link rel="prev" href="../">
      
      
        <link rel="next" href="../pasta/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>APT - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#advanced-persistent-thread-apt-emulation" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              APT
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_3" checked>
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    APT
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#intro" class="md-nav__link">
    Intro
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#config-generation" class="md-nav__link">
    Config Generation
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#regions" class="md-nav__link">
    Regions
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#apt-families" class="md-nav__link">
    APT Families
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#apt-profiles" class="md-nav__link">
    APT Profiles
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#commands" class="md-nav__link">
    Commands
  </a>
  
    <nav class="md-nav" aria-label="Commands">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#create-a-new-apt-profile" class="md-nav__link">
    Create a New APT Profile
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#activate-an-apt-profile" class="md-nav__link">
    Activate an APT Profile
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#dns-records" class="md-nav__link">
    DNS Records
  </a>
  
    <nav class="md-nav" aria-label="DNS Records">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#lookup" class="md-nav__link">
    Lookup
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#unregister-register" class="md-nav__link">
    Unregister / Register
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#geolocate" class="md-nav__link">
    Geolocate
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="advanced-persistent-thread-apt-emulation">Advanced Persistent Thread (APT) Emulation<a class="headerlink" href="#advanced-persistent-thread-apt-emulation" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#advanced-persistent-thread-apt-emulation">Advanced Persistent Thread (APT) Emulation</a><ul>
<li><a href="#intro">Intro</a></li>
<li><a href="#config-generation">Config Generation</a></li>
<li><a href="#regions">Regions</a></li>
<li><a href="#apt-families">APT Families</a></li>
<li><a href="#apt-profiles">APT Profiles</a></li>
<li><a href="#commands">Commands</a><ul>
<li><a href="#create-a-new-apt-profile">Create a New APT Profile</a></li>
<li><a href="#activate-an-apt-profile">Activate an APT Profile</a></li>
<li><a href="#dns-records">DNS Records</a><ul>
<li><a href="#lookup">Lookup</a></li>
<li><a href="#unregister-register">Unregister / Register</a></li>
</ul>
</li>
<li><a href="#geolocate">Geolocate</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<h2 id="intro">Intro<a class="headerlink" href="#intro" title="Permanent link">&para;</a></h2>
<p>Real-world <a href="https://csrc.nist.gov/topics/security-and-privacy/risk-management/threats/advanced-persistent-threats">APTs</a> use infrastructure and <a href="https://csrc.nist.gov/glossary/term/Tactics_Techniques_and_Procedures">TTPs</a>.
Defenders and Cyber Threat Analysts identify these things, and attempt to coorelate related <a href="https://csrc.nist.gov/glossary/term/ioc">IoCs</a>
and attribute them to a particular actor.</p>
<p>Each APT may have their own unique TTPs, goals, or targets.
APTs can be related to each other (perhaps backed by the same entity). These connections are often revealed when IoCs / TTPs are observed to overlap between actors.</p>
<p><code>autovnet</code> allows you to roleplay as an APT, with a particular set of TTPs and infrastructure (IP addresses, <code>dns</code> names, etc.)</p>
<p>By default, <code>autovnet</code> commands roll random infrastructure from the default infrastructure pool (the giant block of IP addresses assigned to the <code>autovnet server</code> as part of the game config).</p>
<p>To roleplay as an APT, <code>autovnet</code> allows you to partion a subset of the available infrastructure to serve as your APT's infrastructure.
This collection of infrastructure (IP blocks, <code>dns</code> names, etc.) is refered to as an <code>APT profile</code>.</p>
<p>When an APT profile is active, <code>autovnet</code> commands that you run will draw IP addresses from the pool associated with your APT (as stored in your APT profile).</p>
<h2 id="config-generation">Config Generation<a class="headerlink" href="#config-generation" title="Permanent link">&para;</a></h2>
<p>Some APT information is generated as part of the <code>autovnet</code> game configuration, and distributed to all players as part of the game config.</p>
<p>When the game config is generated on the <code>autovnet</code> server, the entire IP pool is partitioned into <code>regions</code> and <code>APT Families</code>, described below.</p>
<ul>
<li>This is done in large CIDR blocks, so the resulting data is reasonably sized</li>
</ul>
<p>This means that all IPs in the <code>autovnet</code> pool can be categorized with a paricular <code>region</code> and <code>APT Family</code>.</p>
<ul>
<li><code>UNKNOWN</code> is treated as a special value</li>
</ul>
<h2 id="regions">Regions<a class="headerlink" href="#regions" title="Permanent link">&para;</a></h2>
<p>Each IP address in the <code>autovnet</code> pool belongs to a <code>region</code>.
The real-world analog is a geo-locatable area, like <code>France</code>, <code>Canada</code>, etc.
By default, apolitical names <code>alpha</code>, <code>bravo</code>, ... <code>zulu</code> are used as the regions.</p>
<p>Logically, the location of an IP address is not powerful evidence that an APT is located in the same region. E.g. use of an IP in <code>delta</code> does not mean that the APT is based there.
However, patterns may emerge that do increase the confidence of geolocating an APT</p>
<ul>
<li>e.g. if an APT's C2 servers are always hosted in the <code>delta</code> region, and all victims are from the <code>alpha</code> or <code>echo</code> region, and <code>alpha</code> and <code>echo</code> are known adversaries of <code>delta</code>, then perhaps the APT is <code>delta</code>-based APT targeting <code>alpha</code> and <code>echo</code></li>
</ul>
<p>Currently, regions in <code>autovnet</code> are cosmetic classifiers with no intrinsic meaning, but their existence increases roleplay potential.</p>
<p>Regions are distributed as part of the game configuration.</p>
<h2 id="apt-families">APT Families<a class="headerlink" href="#apt-families" title="Permanent link">&para;</a></h2>
<p>An APT Family is a pool of infrastructure from which individual APT profiles can be created.</p>
<p>The real-world analog is a logical Advanced Persisent Threat actor / sponsor, similar to the "Suspected attribution" from <a href="https://www.mandiant.com/resources/apt-groups">Mandiant</a>.</p>
<p>An APT Family's infrastructure likely spans many regions.</p>
<p>Many APT profiles can belong to the same Family.</p>
<p>APT Families add roleplaying potential, and the potential for clustering individual APTs based on some (intentional) commonality shared within a Family.</p>
<p>APT Families are distributed as part of the game configuration.</p>
<h2 id="apt-profiles">APT Profiles<a class="headerlink" href="#apt-profiles" title="Permanent link">&para;</a></h2>
<p>An APT profile is a concrete set of infrastructure that is logically available to an APT to use for its malicous activity.</p>
<p>In <code>autovnet</code>, individual players generate APT profiles, and they are not shared between players by default.</p>
<ul>
<li>By default, "sharing between players" happens at the APT Family level</li>
<li>Players can choose to share their APT profiles by placing them in a <a href="https://autovtools.gitlab.io/autovrtfm/autovnet-docs/usage/collaboration/fs/">shared directory</a> or otherwise distributing them<ul>
<li>Be mindful that the likelihood of commands failing due to IP conflicts increases as APT profile size decreases</li>
</ul>
</li>
</ul>
<p>When generating an APT profile, the player provides a <code>size</code>, when controls how much infrastructure will be allocated.</p>
<ul>
<li>
<p>Because of how <code>autovnet</code> works, "allocated" doesn't mean much - the "infrastructure" is just a random IP stored in a text file</p>
<ul>
<li>Future <code>autovnet</code> commands might read that text file and use that random IP</li>
<li>So the IP is "allocated", with 0 actual resource cost</li>
<li>The real allocation happens when you actually try to use the IP, and because of math, it's extremely unlikely to conflict with any other players.</li>
</ul>
</li>
<li>
<p>The <code>sizes</code> and their meanings are defined in <code>templates.yaml</code>, distributed as part of the game config</p>
</li>
</ul>
<p>To avoid "attribution by proximity" (i.e. attributing an entire block of IP addresses to a particular actor due to knowledge of how <code>autovnet</code> does IP partioning), APT profiles use much smaller CIDR blocks (often, <code>/32</code>).</p>
<p>Because there are potentionally <em>billions</em> of IPs in the game, we have to be careful: going too overboard with infrastructure could result in APT profile files that are GBs large.
We want to keep them manageable, to save our disk space and let them fit in RAM.</p>
<p>Because of this, super big APT profiles have some features disabled.</p>
<ul>
<li><code>dns</code>: reasonably-sized APT profiles pre-register DNS names for each IP in the profile</li>
<li><code>geo</code>: reasonably-sized APT profiles pre-geolocate each IP</li>
</ul>
<h2 id="commands">Commands<a class="headerlink" href="#commands" title="Permanent link">&para;</a></h2>
<h3 id="create-a-new-apt-profile">Create a New APT Profile<a class="headerlink" href="#create-a-new-apt-profile" title="Permanent link">&para;</a></h3>
<p>Generate a new APT profile.</p>
<p><strong>This does not activate the APT profile</strong></p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>new
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>APT<span class="w"> </span>Family:<span class="w"> </span>HORSE
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Assigning<span class="w"> </span>infrastructure<span class="w"> </span><span class="o">(</span><span class="nv">size</span><span class="o">=</span>default<span class="o">)</span>...
_<span class="w">  </span>_<span class="w"> </span>_<span class="w">  </span>_<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>_<span class="w"> </span>____<span class="w"> </span>___<span class="w">     </span>_<span class="w">  </span>_<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>
<span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="w">   </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="o">[</span>__<span class="w">  </span><span class="p">|</span>___<span class="w"> </span>
<span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span><span class="p">|</span>__/<span class="w">    </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span>___<span class="o">]</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span>


<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>name:<span class="w"> </span>hurried_horse
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun:<span class="w"> </span><span class="m">32</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>proxy:<span class="w"> </span><span class="m">160</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>listen:<span class="w"> </span><span class="m">32</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>total:<span class="w"> </span><span class="m">224</span>
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Creating<span class="w"> </span><span class="m">224</span><span class="w"> </span>DNS<span class="w"> </span>records...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns:<span class="w"> </span><span class="m">224</span><span class="w"> </span>records<span class="w"> </span>created
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>profile:<span class="w"> </span>/opt/rtfm/apt/profiles/hurried_horse/hurried_horse.yaml
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>activate:<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>shell<span class="w"> </span>hurried_horse
</code></pre></div>
<h3 id="activate-an-apt-profile">Activate an APT Profile<a class="headerlink" href="#activate-an-apt-profile" title="Permanent link">&para;</a></h3>
<p>Drop into a shell with the APT profile active.</p>
<p><strong>The APT profile is only active in the current shell</strong></p>
<p>To help you track which profile, if any, is active, <code>autovnet</code> will attempt to update your shell prompt.</p>
<p>There is also a <code>show</code> command that will display your active APT's stats.</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>rtfm<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>shell<span class="w"> </span>hurried_horse<span class="w"> </span>
<span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>show
_<span class="w">  </span>_<span class="w"> </span>_<span class="w">  </span>_<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>_<span class="w"> </span>____<span class="w"> </span>___<span class="w">     </span>_<span class="w">  </span>_<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>____<span class="w"> </span>
<span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="w">   </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__/<span class="w"> </span><span class="o">[</span>__<span class="w">  </span><span class="p">|</span>___<span class="w"> </span>
<span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span><span class="p">|</span>__/<span class="w">    </span><span class="p">|</span><span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="p">|</span>__<span class="p">|</span><span class="w"> </span><span class="p">|</span><span class="w">  </span><span class="se">\ </span>___<span class="o">]</span><span class="w"> </span><span class="p">|</span>___<span class="w"> </span>


<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>name:<span class="w"> </span>hurried_horse
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>tun:<span class="w"> </span><span class="m">32</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>proxy:<span class="w"> </span><span class="m">160</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>listen:<span class="w"> </span><span class="m">32</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>total:<span class="w"> </span><span class="m">224</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>profile:<span class="w"> </span>/opt/rtfm/apt/profiles/hurried_horse/hurried_horse.yaml
</code></pre></div>
<p>Now that a profile is active, we can verify that new <code>autovnet</code> commands (in the same shell) now draw IPs from the APT's pool, not the global <code>autovnet</code> pool.</p>
<p>In this case, there are <code>224</code> IPs available to the APT.
  * The IPs are categorized (<code>tun</code>, <code>proxy</code>, <code>listen</code>, etc.)
  * The <code>tun</code> command uses the <code>tun</code> pool, the <code>proxy</code> command uses the <code>proxy</code> pool, etc.</p>
<p>The easiest way to prove that your "random" IP addresses are being drawn from your APT pool is with some experimentation.</p>
<ol>
<li>Generate a very large number of "random" IPs</li>
<li>Count the number of unique IPs</li>
<li>If we generated enough "random" IPs, we expect exactly <code>224</code> unique IPs, since those are the only "valid" IPs to draw from</li>
</ol>
<p><div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="w"> </span>-c<span class="w"> </span><span class="m">8192</span><span class="w"> </span><span class="p">|</span><span class="w"> </span>sort<span class="w"> </span>-u<span class="w"> </span><span class="p">|</span><span class="w"> </span>wc<span class="w"> </span>-l
<span class="m">224</span>
</code></pre></div>
When we run the same test with no active APT profile, IPs are drawn from the whole <code>autovnet</code> pool, which is so large, we expect few (if any) duplicates.</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span><span class="nb">exit</span>

<span class="o">(</span>rtfm<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>show
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>No<span class="w"> </span>active<span class="w"> </span>profile<span class="w"> </span><span class="o">(</span>AVN_APT<span class="o">)</span><span class="w"> </span>not<span class="w"> </span><span class="nb">set</span>

<span class="o">(</span>rtfm<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="w"> </span>-c<span class="w"> </span><span class="m">8192</span><span class="w"> </span><span class="p">|</span><span class="w"> </span>sort<span class="w"> </span>-u<span class="w"> </span><span class="p">|</span><span class="w"> </span>wc<span class="w"> </span>-l
<span class="m">8192</span>
</code></pre></div>
<h3 id="dns-records">DNS Records<a class="headerlink" href="#dns-records" title="Permanent link">&para;</a></h3>
<p>Depending on the <code>size</code> of your APT, you may have DNS names pre-registered for your infrastructure.</p>
<p>All but the largest sizes of APTs will pre-register DNS names by default.</p>
<p>Extremely large APT profiles should not pre-register DNS names, since it will make the profile very large, and it will create a lot of DNS records that will probably never be used.
If you need a large APT profile, just manually create your DNS records with the <a href="../../rdn/dns/"><code>autovnet rtfm dns</code> command(s)</a>.</p>
<p>Whether a new APT will pre-create these records is based on the <code>size</code>, and is controlled by <code>templates.yaml</code> in the game config.</p>
<p>The hostname / IP mapping is stored locally in the APT profile.</p>
<h4 id="lookup">Lookup<a class="headerlink" href="#lookup" title="Permanent link">&para;</a></h4>
<p>You can look up a host nmae by IP address locally (no actual DNS query, just checking your profile) with the <code>autovnet apt dns</code> command.
<strong>You must have an APT profile activated</strong></p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span><span class="nv">IP</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nb">echo</span><span class="w"> </span>-e<span class="w"> </span><span class="s2">&quot;IP: </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="s2">\nHOSTNAME: </span><span class="k">$(</span>autovnet<span class="w"> </span>apt<span class="w"> </span>dns<span class="w"> </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="k">)</span><span class="s2">&quot;</span>
IP:<span class="w"> </span><span class="m">244</span>.156.107.60
HOSTNAME:<span class="w"> </span>clear.response.avn
</code></pre></div>
<p>Tab completion is also helpful here, and allows you to potentionally "resolve" your IPs of interest without actually running the command.</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>dns<span class="w"> </span><span class="m">240</span><span class="o">[</span>TAB<span class="o">]</span>
<span class="m">240</span>.145.196.80<span class="w">   </span>--<span class="w"> </span>orange.nature.avn
<span class="m">240</span>.145.196.81<span class="w">   </span>--<span class="w"> </span>joyous.possibility.avn
<span class="m">240</span>.145.196.82<span class="w">   </span>--<span class="w"> </span>parsimonious.occasion.avn
<span class="m">240</span>.145.196.83<span class="w">   </span>--<span class="w"> </span>abnormal.mistake.avn
<span class="m">240</span>.159.111.205<span class="w">  </span>--<span class="w"> </span>unkempt.mess.avn
...
</code></pre></div>
<p>You can also just search your APT profile file, if desired.</p>
<h4 id="unregister-register">Unregister / Register<a class="headerlink" href="#unregister-register" title="Permanent link">&para;</a></h4>
<p>If desired, you can manually register / unregister the batch of DNS mappings stored in your APT profile.</p>
<p>We can demonstrate this with a oneliner that</p>
<ul>
<li>Draws a random IP</li>
<li>Looks up the associated DNS name (from profile)</li>
<li>Performs an actual DNS query on the DNS name</li>
</ul>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span><span class="nv">IP</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">HOSTNAME</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>apt<span class="w"> </span>dns<span class="w"> </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">RESOLVED</span><span class="o">=</span><span class="k">$(</span>dig<span class="w"> </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="w"> </span>+short<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nb">echo</span><span class="w"> </span>-e<span class="w"> </span><span class="s2">&quot;IP: </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="s2">\nHOSTNAME: </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="s2">\nRESOLVED: </span><span class="si">${</span><span class="nv">RESOLVED</span><span class="si">}</span><span class="s2">&quot;</span><span class="w"> </span>
IP:<span class="w"> </span><span class="m">254</span>.32.142.251
HOSTNAME:<span class="w"> </span>minor.penalty.avn
RESOLVED:<span class="w"> </span><span class="m">254</span>.32.142.251
</code></pre></div>
<p>After unregistering, the DNS resolution fails, leaving the <code>RESOLVED</code> field blank in our test</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>unregister
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Unregister<span class="w"> </span><span class="m">224</span><span class="w"> </span>DNS<span class="w"> </span>records...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns:<span class="w"> </span><span class="m">224</span><span class="w"> </span>records<span class="w"> </span>deleted

<span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span><span class="nv">IP</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">HOSTNAME</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>apt<span class="w"> </span>dns<span class="w"> </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">RESOLVED</span><span class="o">=</span><span class="k">$(</span>dig<span class="w"> </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="w"> </span>+short<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nb">echo</span><span class="w"> </span>-e<span class="w"> </span><span class="s2">&quot;IP: </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="s2">\nHOSTNAME: </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="s2">\nRESOLVED: </span><span class="si">${</span><span class="nv">RESOLVED</span><span class="si">}</span><span class="s2">&quot;</span>
IP:<span class="w"> </span><span class="m">252</span>.230.175.124
HOSTNAME:<span class="w"> </span>childlike.relative.avn
RESOLVED:
</code></pre></div>
<p>After re-registering, the <code>RESOLVED</code> field returns, since the DNS query succeeds.</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>register
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Creating<span class="w"> </span><span class="m">224</span><span class="w"> </span>DNS<span class="w"> </span>records...
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>dns:<span class="w"> </span><span class="m">224</span><span class="w"> </span>records<span class="w"> </span>created

<span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet.local<span class="w"> </span>git:<span class="o">(</span>dev<span class="o">)</span><span class="w"> </span>✗<span class="w"> </span><span class="nv">IP</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">HOSTNAME</span><span class="o">=</span><span class="k">$(</span>autovnet<span class="w"> </span>apt<span class="w"> </span>dns<span class="w"> </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nv">RESOLVED</span><span class="o">=</span><span class="k">$(</span>dig<span class="w"> </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="w"> </span>+short<span class="k">)</span><span class="p">;</span><span class="w"> </span><span class="nb">echo</span><span class="w"> </span>-e<span class="w"> </span><span class="s2">&quot;IP: </span><span class="si">${</span><span class="nv">IP</span><span class="si">}</span><span class="s2">\nHOSTNAME: </span><span class="si">${</span><span class="nv">HOSTNAME</span><span class="si">}</span><span class="s2">\nRESOLVED: </span><span class="si">${</span><span class="nv">RESOLVED</span><span class="si">}</span><span class="s2">&quot;</span>
IP:<span class="w"> </span><span class="m">255</span>.242.225.112
HOSTNAME:<span class="w"> </span>thoughtless.blind.avn
RESOLVED:<span class="w"> </span><span class="m">255</span>.242.225.112
</code></pre></div>
<h3 id="geolocate">Geolocate<a class="headerlink" href="#geolocate" title="Permanent link">&para;</a></h3>
<p><code>geo</code> is exactly like <code>dns</code>, but it returns the <code>region</code> of the IP, not the DNS name.</p>
<div class="highlight"><pre><span></span><code><span class="o">(</span>hurried_horse<span class="o">)</span><span class="w"> </span>$<span class="w"> </span>autovnet<span class="w"> </span>apt<span class="w"> </span>geo<span class="w"> </span><span class="k">$(</span>autovnet<span class="w"> </span>net<span class="w"> </span>ip<span class="k">)</span>
delta
</code></pre></div>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>